using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;

namespace F90766
{
    public partial class Form1 : Form
    {
        private int rowcount = 10;
        string[] dept = { "CIVIL ENGINEERING", "MECHANICAL ENGINEERING", "INFORMATION TECHNOLOGY", "COMPUTERSCIENCE ENGINEERING", "BIO-TECHNOLOGY", "AERONAUTICAL ENGINEERING", "MARINEENGINEERING", "TEXTILE ENGINEERING", "ELECTRICAL ENGINEERING", "ELECTRONICS ENGINEERING" };
        private string[] year ={ "I", "II", "III", "IV" };
        private DataTable dt;
        private ToolTip toolTip1;
        private StringCollection choiceList;

        public Form1()
        {
            InitializeComponent();
            toolTip1 = new ToolTip();
            choiceList = new StringCollection();
            choiceList.AddRange(dept);

            #region Data
            dt = new DataTable();
            dt.Columns.Add("SNo");
            dt.Columns.Add("StudentID");
            dt.Columns.Add("Department");
            dt.Columns.Add("Year");
            dt.Columns.Add("Location");

            Random r = new Random(124321);
            for (int i = 0; i < rowcount; i++)
            {
                DataRow dr = dt.NewRow();
                if ((i + 1) < 10)
                {
                    dr[0] = "0" + (i + 1).ToString();
                    dr[1] = "S" + "0" + (i + 1).ToString();
                }
                else
                {
                    dr[0] = (i + 1).ToString();
                    dr[1] = "S" + (i + 1).ToString();
                }
                dr[2] = dept[r.Next(0, 9)];
                dr[3] = year[r.Next(0, 3)];
                dr[4] = "City";
                dt.Rows.Add(dr);
            }
            #endregion

            this.gridControl1.PopulateValues(GridRangeInfo.Cells(1, 1, 10, 5), dt);
            this.gridControl1.ColStyles[3].CellType = "ComboBox";
            this.gridControl1.ColStyles[3].ChoiceList = choiceList;

            this.gridControl1.MouseMove += new MouseEventHandler(gridControl1_MouseMove);
        }

        int row1, col1 = -1;
        int colWidth;
        void gridControl1_MouseMove(object sender, MouseEventArgs e)
        {
            int row, col;
            if (this.gridControl1.PointToRowCol(new Point(e.X, e.Y), out row, out col) && (col != col1 || row != row1))
            {
                col1 = col;
                row1 = row;
                if (this.toolTip1 != null && this.toolTip1.Active)
                    this.toolTip1.Active = false;
                Graphics g = CreateGraphics();
                GridStyleInfo style = this.gridControl1[row, col];
                
                if(style.CellType == "ComboBox")
                    colWidth = this.gridControl1.ColWidths[col] - style.TextMargins.Left - style.TextMargins.Right - style.CellModel.ButtonBarSize.Width;
                else
                    colWidth = this.gridControl1.ColWidths[col] - style.TextMargins.Left - style.TextMargins.Right;
                if (colWidth  < g.MeasureString(style.Text, style.GdipFont).Width)
                {
                    toolTip1.SetToolTip(this.gridControl1, this.gridControl1[row1, col1].Text);
                    toolTip1.Active = true;
                }
                g.Dispose();
            }             
        }
    }
}